class Build
	require "aml/Argument"
	require 'fileutils'
	def initialize(attribute=nil)
		@argument = Argument.new()
		@argument.define('[n]ame', nil, 'directory name of site', true)
		@argument.define('[t]emplate', 'default', 'site template to use', true)
		@argument.define('[v]ersion', nil, 'template version to use', false)
		@argument.define('[h]elp', false, 'list all arguments')
		@argument.parse(attribute)
		#Short hand options for quick name and template
		arguments = attribute.split('--')
		if arguments.count == 1
			arguments = []
			io = attribute.split(' ')
			arguments << "name " + io[0]
			arguments << "template " + io[1] if io.count == 2
		end
		arguments.each do |argument|
			string = argument.split(' ')
			@argument.set(string[0], string[1..string.count].join(' ').to_s) if argument.strip.length > 0
		end
		if @argument.show_help?
			@argument.show_help
		elsif @argument.has_requirements?
			template_path = File.join(File.dirname(File.expand_path(__FILE__)),'core',@argument.get('template').downcase)
			name_path = File.join(File.dirname(File.expand_path(@argument.get('name').downcase)),@argument.get('name').downcase)
			if Dir.exists? template_path
				versions = Dir.entries(File.join(Dir.glob(template_path)))
				versions = versions[2...versions.count].sort
				@argument.set('version', versions.last) if @argument.get('version').to_s.strip.length == 0
				if versions.include? @argument.get('version')
					if Dir.exists? name_path
						puts "cannot overwrite existing #{@argument.get('name').downcase} directory"
					else
						Dir.mkdir name_path unless Dir.exists? name_path
						FileUtils.cp_r Dir.glob(File.join(template_path, @argument.get('version'), '*')), name_path
						puts "#{@argument.get('template').downcase} v#{@argument.get('version')} starter kit has been created in #{@argument.get('name').downcase}"
					end
				else
					puts "#{@argument.get('template').downcase} version does not exist, try one of the following:"
					versions.reverse.each do |version|
						is_default = version == versions.last ? " [default]" : ""
						puts "- #{version} #{is_default}"
					end
				end
			else
				puts "#{@argument.get('template').downcase} starter kit does not exist"
			end
		else
			@argument.show_required
		end

	end
end